
insmod /system/lib/modules/ext2.ko

if [ ! -d /data/sd-ext ]; then
    busybox mount -o rw,remount /
    mkdir /data/sd-ext
    busybox chown 1000:1000 /data/sd-ext
    busybox chmod 777 /data/sd-ext
    busybox mount -o ro,remount /
fi
mkdir /data/sd-ext

if [ -e /dev/block/mmcblk0p2 ]; then
    /system/xbin/mount -t ext2 /dev/block/mmcblk0p2 /data/sd-ext
    if [ -d /data/app ]; then
        mkdir /data/sd-ext/app21
        chmod 777 /data/sd-ext/app21
        cp -a /data/app/* /data/sd-ext/app21/
        rm -r /data/app
        ln -s /data/sd-ext/app21 /data/app
    fi
    if [ -d /data/app-private ]; then
        mkdir /data/sd-ext/app-private21
        chmod 777 /data/sd-ext/app-private21
        cp -a /data/app-private/* /data/sd-ext/app-private21/
        rm -r /data/app-private
        ln -s /data/sd-ext/app-private21 /data/app-private
    fi
else
    if [ -L /data/app ]; then
        rm /data/app
        mkdir /data/app
        chmod 771 /data/app
        chown 1000:1000 /data/app
    fi
    if [ -L /data/app-private ]; then
        rm /data/app-private
        mkdir /data/app-private
        chmod 771 /data/app-private
        chown 1000:1000 /data/app-private
    fi
    if [ -L /data/dalvik-cache ]; then
        rm /data/dalvik-cache
        mkdir /data/dalvik-cache
        chmod 771 /data/dalvik-cache
        chown 1000:1000 /data/dalvik-cache
    fi
fi

